import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import RestClient from "/apps/websight-rest-atlaskit-client/web-resources/js/RestClient.js";
import ReplicationActionService from "../services/ReplicationActionService.js";
import ConfirmationModal from "/apps/websight-admin/web-resources/ConfirmationModal.js";
const AuthorizableUnpublishAction = {
  restClient: new RestClient('websight-aem-replication-support-service'),
  label: 'Unpublish',

  onClick() {
    this.actionModal.open();
  },

  isApplicable(path, callback) {
    ReplicationActionService.isApplicable(path, callback, callback(false));
  },

  unpublishAuthorizable(path, type) {
    this.restClient.post({
      action: 'unpublish',
      data: {
        path: path,
        type: type
      },
      always: () => {
        this.actionModal.close();
      }
    });
  },

  modal(authorizable) {
    const type = authorizable.path.startsWith('/home/users') ? 'user' : 'group';
    const heading = 'Unpublish ' + type;
    return /*#__PURE__*/React.createElement(ConfirmationModal, {
      buttonText: 'Unpublish',
      heading: heading,
      message: /*#__PURE__*/React.createElement("span", null, "Are you sure you want to unpublish ", /*#__PURE__*/React.createElement("b", null, authorizable.displayName), "?"),
      onConfirm: () => this.unpublishAuthorizable(authorizable.path, type),
      ref: element => this.actionModal = element
    });
  }

};
export default AuthorizableUnpublishAction;