import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import RestClient from "/apps/websight-rest-atlaskit-client/web-resources/js/RestClient.js";
import ReplicationActionService from "../services/ReplicationActionService.js";
import ConfirmationModal from "/apps/websight-admin/web-resources/ConfirmationModal.js";
const PackageUnpublishAction = {
  restClient: new RestClient('websight-aem-replication-support-service'),
  label: 'Unpublish',

  onClick() {
    this.actionModal.open();
  },

  isApplicable(path, callback) {
    ReplicationActionService.isApplicable(path, callback, callback(false));
  },

  unpublishPackage(path) {
    this.restClient.post({
      action: 'unpublish',
      data: {
        path: path,
        type: 'package'
      },
      always: () => {
        this.actionModal.close();
      }
    });
  },

  modal(packageData) {
    return /*#__PURE__*/React.createElement(ConfirmationModal, {
      buttonText: 'Unpublish',
      heading: 'Unpublish package',
      message: /*#__PURE__*/React.createElement("span", null, "Are you sure you want to unpublish ", /*#__PURE__*/React.createElement("b", null, packageData.name), "?"),
      onConfirm: () => this.unpublishPackage(packageData.path),
      ref: element => this.actionModal = element
    });
  }

};
export default PackageUnpublishAction;