import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import Button, { ButtonGroup } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/button.js";
import { Section } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/menu.js";
import ModalDialog, { ModalTransition } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/modal-dialog.js";
import Textfield from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/textfield.js";
import Form, { FormFooter } from "/apps/websight-rest-atlaskit-client/web-resources/js/Form.js";
import RestClient from "/apps/websight-rest-atlaskit-client/web-resources/js/RestClient.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
const Message = styled.div`
    padding-top: 10px;
`;
export default class ResourceUnpublishModal extends React.PureComponent {
  constructor(props) {
    super(props);
    this.restClient = new RestClient('websight-aem-replication-support-service');
    this.state = {
      isOpen: false,
      submitDisabled: true,
      resource: null
    };
    this.open = this.open.bind(this);
    this.close = this.close.bind(this);
    this.onFormSubmit = this.onFormSubmit.bind(this);
  }

  open(resource) {
    this.setState({
      isOpen: true,
      resource: resource,
      submitDisabled: true
    });
  }

  close() {
    this.setState({
      isOpen: false
    });
  }

  onFormSubmit() {
    this.restClient.post({
      action: 'resource-unpublish',
      data: {
        path: this.state.resource.path,
        type: 'resource'
      },
      always: () => {
        this.close();
      }
    });
  }

  render() {
    const {
      isOpen,
      submitDisabled,
      resource
    } = this.state;
    return /*#__PURE__*/React.createElement(ModalTransition, null, isOpen && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ModalDialog, {
      onClose: this.close,
      heading: "Unpublish resource",
      width: "large"
    }, /*#__PURE__*/React.createElement(Form, {
      onSubmit: this.onFormSubmit,
      onSuccess: this.close
    }, ({
      submitted
    }) => /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Section, {
      hasSeparator: true
    }, /*#__PURE__*/React.createElement(Message, null, 'The resource and all it\'s children will be removed from publish instances'), /*#__PURE__*/React.createElement(Message, null, 'Type the following path to confirm: ', /*#__PURE__*/React.createElement("span", {
      style: {
        fontWeight: 'bold'
      }
    }, resource.path)), /*#__PURE__*/React.createElement(Textfield, {
      name: "path",
      label: "Resource path",
      isRequired: true,
      autoFocus: true,
      onChange: event => {
        this.setState({
          submitDisabled: resource.path !== event.target.value
        });
      }
    })), /*#__PURE__*/React.createElement(FormFooter, null, /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
      appearance: "primary",
      autoFocus: true,
      type: "submit",
      isLoading: submitted,
      isDisabled: submitDisabled
    }, "Unpublish"), /*#__PURE__*/React.createElement(Button, {
      appearance: "subtle",
      onClick: this.close,
      isDisabled: submitted
    }, "Cancel"))))))));
  }

}