import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import { colors } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/theme.js";
import Logo from "./Logo.js";
const FooterElement = styled.div`
    display: flex;
    flex-direction: column;
    align-items: center;
    margin: 20px 10px
`;
const ElementsContainer = styled.ul`
    padding-left: 0;
`;
const LinkElement = styled.li`
    display: inline;

    &:not(:first-child) {
        margin-left: 10px;
    }

    &:not(:last-child):after {
        content: '\\B7';
        margin-left: 10px;
    }
`;
const Hyperlink = styled.a`
    color: ${colors.N100};
    cursor: pointer;
`;
const LogoContainer = styled.div`
    margin-top: 10px;
`;
export default class Footer extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      versionReportModal: null
    };
  }

  openSystemVersion() {
    import("./VersionReportModal.js").then(versionReportModal => {
      this.setState({
        versionReportModal: /*#__PURE__*/React.createElement(versionReportModal.default, {
          ref: element => this.versionReportModalRef = element
        })
      }, () => this.versionReportModalRef.open());
    }).catch(error => {
      console.error(error);
    });
  }

  render() {
    return /*#__PURE__*/React.createElement(FooterElement, null, /*#__PURE__*/React.createElement(ElementsContainer, null, /*#__PURE__*/React.createElement(LinkElement, null, /*#__PURE__*/React.createElement(Hyperlink, {
      onClick: () => this.openSystemVersion()
    }, "System Version")), /*#__PURE__*/React.createElement(LinkElement, null, /*#__PURE__*/React.createElement(Hyperlink, {
      href: "https://websight.ds.pl"
    }, "About WebSight")), /*#__PURE__*/React.createElement(LinkElement, null, /*#__PURE__*/React.createElement(Hyperlink, {
      href: "https://www.ds.pl/contact-us.html"
    }, "Contact Us"))), /*#__PURE__*/React.createElement(LogoContainer, null, /*#__PURE__*/React.createElement(Logo, null)), this.state.versionReportModal);
  }

}