import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import Modal, { ModalTransition } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/modal-dialog.js";
const BundlesContainer = styled.div`
    margin: 10px 0;
`;
const BUNDLES_VERSION_URL = '/apps/websight-system-status/bin/bundles-version-list';
export default class VersionReportModal extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false,
      bundles: []
    };
    this.getBundleVersionReportList();
    this.open = this.open.bind(this);
    this.close = this.close.bind(this);
  }

  getBundleVersionReportList() {
    fetch(BUNDLES_VERSION_URL).then(response => {
      const contentType = response.headers.get('content-type');

      if (contentType && contentType.startsWith('application/json')) {
        response.json().then(data => this.setState({
          bundles: data
        }));
      }
    }).catch(error => {
      console.error(error);
    });
  }

  open() {
    this.setState({
      isOpen: true
    });
  }

  close() {
    this.setState({
      isOpen: false
    });
  }

  render() {
    const {
      isOpen,
      bundles
    } = this.state;
    return /*#__PURE__*/React.createElement(ModalTransition, null, isOpen && /*#__PURE__*/React.createElement(Modal, {
      onClose: this.close,
      heading: "System Components",
      width: "large"
    }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("p", null, "Copyright \xA9 2020 Dynamic Solutions Sp. z o.o. Sp. k."), /*#__PURE__*/React.createElement("p", null, "This product includes the following system components:")), /*#__PURE__*/React.createElement(BundlesContainer, null, /*#__PURE__*/React.createElement("ol", null, Object.keys(bundles).map(key => {
      return /*#__PURE__*/React.createElement("li", {
        key: key
      }, bundles[key].name + ' (' + bundles[key].version + ')');
    })))));
  }

}