function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import RestClient from "/apps/websight-rest-atlaskit-client/web-resources/js/RestClient.js";

const getWebFragments = (fragmentsKey, fragmentsCallback, errorNotification) => {
  const restClient = new RestClient('websight-fragments-registry');
  restClient.get({
    action: 'get-web-fragments',
    parameters: {
      key: fragmentsKey
    },
    onSuccess: data => {
      const imports = data.entity.map(path => import(path));
      Promise.all(imports).then(modules => fragmentsCallback(modules.map(module => module.default))).catch(error => {
        console.warn('Error during loading fragments', error);
        errorNotification('Error during loading content');
      });
    },
    onError: data => errorNotification(data.message, data.messageDetails),
    onNonFrameworkError: data => errorNotification(data.message, data.messageDetails)
  });
};

class WebFragments extends React.Component {
  constructor(props) {
    super(props);
    const {
      fragmentsKey,
      loadingComponent,
      errorNotification,
      ...componentProps
    } = this.props;
    this.state = {
      components: null,
      fragmentsKey: fragmentsKey || console.warn('Fragments key is empty'),
      loadingComponent: loadingComponent,
      errorNotification: errorNotification || console.warn,
      componentProps: componentProps
    };
  }

  componentDidMount() {
    getWebFragments(this.state.fragmentsKey, components => this.setState({
      components: components
    }), this.state.errorNotification);
  }

  render() {
    const {
      components,
      loadingComponent,
      componentProps
    } = this.state;

    if (components === null) {
      if (loadingComponent) {
        return loadingComponent;
      } else {
        return /*#__PURE__*/React.createElement(React.Fragment, null);
      }
    }

    return components.map((Component, index) => /*#__PURE__*/React.createElement(Component, _extends({
      key: index
    }, componentProps)));
  }

}

export { getWebFragments };
export default WebFragments;