function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import Tree, { mutateTree } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/tree.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import { TreeIcon } from "/apps/websight-admin/web-resources/Icons.js";
import { colors } from "/apps/websight-admin/web-resources/theme.js";
const PADDING_PER_LEVEL = 20;
const TreeContainer = styled.div`
    height: 250px;
    overflow: auto;
    padding: 5px;
    border: 1px solid black;
    position: relative;
`;
const TreeItemStyle = {
  display: 'inline',
  padding: '2px'
};
const TreeItemSelectedStyle = {
  display: 'inline',
  padding: '2px',
  background: colors.lightBlue
};

const getIcon = item => {
  if (item.isFolder) {
    return item.isExpanded ? /*#__PURE__*/React.createElement(TreeIcon, {
      className: "material-icons-outlined"
    }, "folder_open") : /*#__PURE__*/React.createElement(TreeIcon, {
      className: "material-icons-outlined"
    }, "folder");
  }

  return /*#__PURE__*/React.createElement(TreeIcon, {
    className: "material-icons"
  }, "insert_drive_file");
};

export default class FilesTree extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      tree: this.props.filesTree
    };
    this.onSelect = this.onSelect.bind(this);
    this.onFolderSelect = this.onFolderSelect.bind(this);
    this.selectItem = this.selectItem.bind(this);
    this.renderItem = this.renderItem.bind(this);
  }

  componentWillReceiveProps(props) {
    const mergeItems = (oldItem = {}, newItem) => ({ ...oldItem,
      ...newItem
    });

    if (Object.keys(props.filesTree) !== Object.keys(this.state.tree)) {
      this.setState(prevState => {
        const treeItemsEntries = Object.entries(props.filesTree.items).map(([key, item]) => [key, mergeItems(prevState.tree.items[key], item)]);
        return {
          tree: { ...props.filesTree,
            items: Object.fromEntries(treeItemsEntries)
          }
        };
      });
    }
  }

  rootItem() {
    return this.state.tree.items[this.state.tree.rootId];
  }

  selectItem(tree, item) {
    const keys = Object.keys(tree.items);
    let newTree = { ...tree
    };
    keys.forEach(id => newTree = mutateTree(newTree, id, {
      isSelected: false
    }));
    let selected = !item.isSelected;

    if (item.isFolder) {
      item.isExpanded ? selected = false : selected = true;
    }

    return mutateTree(newTree, item.id, {
      isSelected: selected
    });
  }

  onFolderSelect(item) {
    this.setState(prevState => {
      const {
        tree
      } = prevState;
      const newTree = this.selectItem(tree, item);
      return {
        tree: mutateTree(newTree, item.id, {
          isExpanded: !item.isExpanded
        })
      };
    }, () => item.isExpanded ? this.props.onSelect(this.rootItem()) : this.props.onSelect(item));
  }

  onSelect(item) {
    this.setState(prevState => {
      const {
        tree
      } = prevState;
      return {
        tree: this.selectItem(tree, item)
      };
    }, () => this.props.onSelect(item.isSelected ? this.rootItem() : item));
  }

  renderItem({
    item,
    provided
  }) {
    return /*#__PURE__*/React.createElement("div", _extends({
      ref: provided.innerRef
    }, provided.draggableProps), /*#__PURE__*/React.createElement("div", {
      onClick: () => {
        if (item.isFolder) {
          this.onFolderSelect(item);
        } else {
          this.onSelect(item);
        }
      },
      style: item.isSelected ? TreeItemSelectedStyle : TreeItemStyle
    }, /*#__PURE__*/React.createElement("span", null, getIcon(item)), /*#__PURE__*/React.createElement("span", {
      style: {
        cursor: 'pointer'
      }
    }, item.name)));
  }

  render() {
    const {
      tree
    } = this.state;
    return /*#__PURE__*/React.createElement(TreeContainer, null, /*#__PURE__*/React.createElement(Tree, {
      tree: tree,
      renderItem: this.renderItem,
      offsetPerLevel: PADDING_PER_LEVEL,
      isDragEnabled: false
    }), this.props.children);
  }

}