import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import { ErrorMessage } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/form.js";
import ModalDialog, { ModalTransition } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/modal-dialog.js";
import Textfield from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/textfield.js";
import { ENTER_KEY_CODE } from "../utils/GroovyConsoleConstants.js";
export default class NewFolderModal extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false,
      folderName: '',
      error: ''
    };
    this.open = this.open.bind(this);
    this.close = this.close.bind(this);
    this.onCreate = this.onCreate.bind(this);
  }

  open() {
    this.setState({
      isOpen: true,
      folderName: '',
      error: ''
    });
  }

  close() {
    this.setState({
      isOpen: false
    });
  }

  onCreate() {
    const {
      folderName
    } = this.state;

    if (!folderName || !folderName.trim()) {
      this.setState({
        error: 'Folder name cannot be blank'
      });
      return;
    }

    this.close();
    this.props.onSuccess(this.state.folderName);
  }

  actions() {
    return [{
      appearance: 'primary',
      text: 'Create',
      onClick: this.onCreate
    }, {
      appearance: 'subtle',
      text: 'Cancel',
      onClick: this.close
    }];
  }

  render() {
    const {
      isOpen,
      folderName,
      error
    } = this.state;
    return /*#__PURE__*/React.createElement(ModalTransition, null, isOpen && /*#__PURE__*/React.createElement(ModalDialog, {
      actions: this.actions(),
      heading: 'Create new folder',
      onClose: this.close,
      components: true
    }, /*#__PURE__*/React.createElement("label", {
      htmlFor: "fileName"
    }, "Folder name"), /*#__PURE__*/React.createElement(Textfield, {
      required: true,
      label: 'fileName',
      name: 'fileName',
      isCompact: true,
      onKeyDown: event => {
        if (event.keyCode === ENTER_KEY_CODE) {
          this.onCreate();
        }
      },
      onChange: event => {
        this.setState({
          folderName: event.target.value
        });
      },
      value: folderName
    }), error && /*#__PURE__*/React.createElement(ErrorMessage, null, error)));
  }

}