function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import { DragDropContext, Droppable } from "/apps/websight-atlaskit-esm/web-resources/react-beautiful-dnd.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import { reorderCollection } from "../../utils/CommonUtils.js";
import { AddButton } from "../AddButton.js";
import PackageFilterRow from "./PackageFilterRow.js";
const FiltersTabContainer = styled.div`
    margin: 10px 0 20px;
    width: 100%;
`;
const emptyFilter = {
  root: '/',
  mode: 'replace',
  rules: []
};
export default class PackageModalFiltersTab {
  constructor(props) {
    this.props = props;
    this.addFilter = this.addFilter.bind(this);
    this.updateFilter = this.updateFilter.bind(this);
    this.removeFilter = this.removeFilter.bind(this);
    this.onDragEnd = this.onDragEnd.bind(this);
  }

  addFilter() {
    const updatedFilters = [...this.props.filters, emptyFilter];
    this.props.updateFilters(updatedFilters);
  }

  updateFilter(indexToUpdate, filterData) {
    const updatedFilters = this.props.filters.map((filter, index) => index === indexToUpdate ? filterData : filter);
    this.props.updateFilters(updatedFilters);
  }

  removeFilter(indexToRemove) {
    const updatedFilters = this.props.filters.filter((filter, index) => index !== indexToRemove);
    this.props.updateFilters(updatedFilters);
  }

  onDragEnd(result) {
    if (!result.destination) {
      return;
    }

    const sourceIndex = result.source.index;
    const destIndex = result.destination.index;

    if (result.type === 'filter') {
      this.props.updateFilters(reorderCollection(this.props.filters, sourceIndex, destIndex));
    } else if (result.type === 'rule') {
      const sourceParentId = parseInt(result.source.droppableId);
      const destParentId = parseInt(result.destination.droppableId);
      let newFilters = [...this.props.filters];
      const sourceSubItems = this.props.filters[sourceParentId].rules;

      if (sourceParentId === destParentId) {
        const reorderedRules = reorderCollection(sourceSubItems, sourceIndex, destIndex);
        newFilters = newFilters.map((filter, filterIndex) => {
          if (filterIndex === sourceParentId) {
            filter.rules = reorderedRules;
          }

          return filter;
        });
        this.props.updateFilters(newFilters);
      }
    }
  }

  render() {
    return /*#__PURE__*/React.createElement(FiltersTabContainer, null, /*#__PURE__*/React.createElement(DragDropContext, {
      onDragEnd: this.onDragEnd
    }, /*#__PURE__*/React.createElement(Droppable, {
      droppableId: "package-droppable-filters",
      type: "filter"
    }, provided => /*#__PURE__*/React.createElement("div", _extends({
      ref: provided.innerRef
    }, provided.droppableProps), this.props.filters.map((filter, filterIndex) => /*#__PURE__*/React.createElement(PackageFilterRow, {
      key: filterIndex,
      filterIndex: filterIndex,
      filter: filter,
      onChange: filterData => this.updateFilter(filterIndex, filterData),
      onRemove: () => this.removeFilter(filterIndex)
    })), provided.placeholder))), /*#__PURE__*/React.createElement(AddButton, {
      onClick: this.addFilter,
      style: {
        margin: '10px 0 0',
        padding: '5px 10px'
      }
    }, "Add Filter"));
  }

}