import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import Tag from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/tag.js";
import Tooltip from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/tooltip.js";
import { colors } from "/apps/websight-admin/web-resources/theme.js";
import { TagIcon } from "/apps/websight-admin/web-resources/Icons.js";
import { WhiteTooltip } from "/apps/websight-admin/web-resources/Tooltips.js";
import { getAuthorizableHash } from "../utils/AuthorizableUtil.js";
import { PRINCIPAL_EVERYONE } from "../utils/UserManagerConstants.js";
const infoTooltipIconStyle = {
  position: 'absolute',
  fontSize: '17px',
  marginTop: '2px',
  marginLeft: '4px'
};
const seeAllLinkStyle = {
  marginLeft: '5px',
  color: colors.grey,
  cursor: 'pointer'
};
const COLLAPSED_TAGS_LIMIT = 3;
export default class AuthorizablesTags extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      expanded: false
    };
  }

  toggle() {
    this.setState(prevState => ({
      expanded: !prevState.expanded
    }));
  }

  render() {
    const Tags = () => {
      let authorizables = this.props.authorizables;

      if (this.props.expandable && !this.state.expanded) {
        authorizables = authorizables.slice(0, COLLAPSED_TAGS_LIMIT);
      }

      return authorizables.map((authorizable, index) => /*#__PURE__*/React.createElement(React.Fragment, null, this.props.onePerLine && index > 0 && /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Tag, {
        key: authorizable.id,
        text: authorizable.displayName || authorizable.id,
        color: colors.grey,
        elemBefore: /*#__PURE__*/React.createElement(TagIcon, {
          className: "material-icons"
        }, authorizable.icon),
        href: getAuthorizableHash(authorizable)
      })));
    };

    if (this.props.authorizableId === PRINCIPAL_EVERYONE) {
      return /*#__PURE__*/React.createElement("span", {
        style: {
          color: colors.grey,
          marginLeft: '4px'
        }
      }, /*#__PURE__*/React.createElement(Tooltip, {
        delay: 0,
        component: WhiteTooltip,
        tag: "span",
        content: 'Group contains all users and groups'
      }, /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("i", null, "everyone"), /*#__PURE__*/React.createElement("i", {
        className: "material-icons-outlined",
        style: infoTooltipIconStyle
      }, "info"))));
    }

    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Tags, null), this.props.expandable && this.props.authorizables.length > COLLAPSED_TAGS_LIMIT && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("a", {
      style: seeAllLinkStyle,
      onClick: () => this.toggle()
    }, this.state.expanded ? 'See less' : 'See all')));
  }

}