import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import Button, { ButtonGroup } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/button.js";
import ModalDialog, { ModalTransition } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/modal-dialog.js";
import TextField from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/textfield.js";
import Form, { FormFooter } from "/apps/websight-rest-atlaskit-client/web-resources/js/Form.js";
import SystemUserService from "./../services/SystemUserService.js";
export default class SystemUserFormModal extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false,
      user: {
        id: ''
      }
    };
    this.open = this.open.bind(this);
    this.close = this.close.bind(this);
    this.onSubmitSuccess = this.onSubmitSuccess.bind(this);
    this.onFormSubmit = this.onFormSubmit.bind(this);
  }

  open() {
    this.setState({
      isOpen: true,
      user: {
        id: ''
      }
    });
  }

  close() {
    this.setState({
      isOpen: false
    });
  }

  onSubmitSuccess(data) {
    this.close();
    this.props.onSaveSuccess && this.props.onSaveSuccess(data);
  }

  onFormSubmit(...args) {
    this.setState({
      user: args[0]
    });
    SystemUserService.createSystemUser(...args);
  }

  render() {
    const {
      isOpen,
      user
    } = this.state;
    const form = /*#__PURE__*/React.createElement(Form, {
      onSubmit: this.onFormSubmit,
      onSuccess: this.onSubmitSuccess
    }, ({
      submitted
    }) => /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextField, {
      autocomplete: "off",
      defaultValue: user.id,
      isRequired: true,
      label: "ID",
      name: "id"
    }), /*#__PURE__*/React.createElement(FormFooter, null, /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
      appearance: "primary",
      type: "submit",
      isLoading: submitted
    }, "Create"), /*#__PURE__*/React.createElement(Button, {
      appearance: "subtle",
      onClick: this.close,
      isDisabled: submitted
    }, "Cancel")))));
    return /*#__PURE__*/React.createElement(ModalTransition, null, isOpen && /*#__PURE__*/React.createElement(ModalDialog, {
      heading: 'Create new system user',
      onClose: this.close
    }, form));
  }

}