import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import Panel from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/panel.js";
import TableTree, { Header, Headers, Rows } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/table-tree.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import { LoadingWrapper } from "/apps/websight-admin/web-resources/Wrappers.js";
import { NoTableDataContainer, TableTopAlignedContainer } from "/apps/websight-admin/web-resources/Containers.js";
import AceRow from "./AceRow.js";
const InheritedEntriesContainer = styled.div`
    margin-top: 64px;
`;
export default class InheritedEntries extends React.Component {
  render() {
    const {
      inheritedEntries,
      isLoadingEntries
    } = this.props;
    const tableTreeHeaders = /*#__PURE__*/React.createElement(Headers, null, /*#__PURE__*/React.createElement(Header, {
      width: 'calc(90% - 700px)'
    }, "Path"), /*#__PURE__*/React.createElement(Header, {
      width: '110px'
    }, "Permission"), /*#__PURE__*/React.createElement(Header, {
      width: '260px'
    }, "Privileges"), /*#__PURE__*/React.createElement(Header, {
      width: 'calc(330px + 10%)'
    }, "Restrictions"));
    return /*#__PURE__*/React.createElement(InheritedEntriesContainer, null, /*#__PURE__*/React.createElement(Panel, {
      header: "Inherited ACEs"
    }, /*#__PURE__*/React.createElement(TableTree, {
      key: "inheritedEntries"
    }, tableTreeHeaders, /*#__PURE__*/React.createElement(LoadingWrapper, {
      isLoading: isLoadingEntries,
      spinnerSize: "large"
    }, /*#__PURE__*/React.createElement(TableTopAlignedContainer, null, /*#__PURE__*/React.createElement(Rows, {
      items: inheritedEntries,
      render: row => /*#__PURE__*/React.createElement(AceRow, {
        isReadOnly: true,
        entry: row
      })
    }), !inheritedEntries.length && !isLoadingEntries && /*#__PURE__*/React.createElement(NoTableDataContainer, null, /*#__PURE__*/React.createElement("i", null, "No Inherited Access Control Entries.")))))));
  }

}